/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/usage.proto

package org.apache.ratis.thirdparty.com.google.api;

/**
 *
 *
 * <pre>
 * Configuration controlling usage of a service.
 * </pre>
 *
 * Protobuf type {@code google.api.Usage}
 */
public final class Usage extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.api.Usage)
    UsageOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use Usage.newBuilder() to construct.
  private Usage(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private Usage() {
    requirements_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
    rules_ = java.util.Collections.emptyList();
    producerNotificationChannel_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new Usage();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private Usage(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              java.lang.String s = input.readStringRequireUtf8();
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                requirements_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000001;
              }
              requirements_.add(s);
              break;
            }
          case 50:
            {
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                rules_ = new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.api.UsageRule>();
                mutable_bitField0_ |= 0x00000002;
              }
              rules_.add(input.readMessage(org.apache.ratis.thirdparty.com.google.api.UsageRule.parser(), extensionRegistry));
              break;
            }
          case 58:
            {
              java.lang.String s = input.readStringRequireUtf8();

              producerNotificationChannel_ = s;
              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        requirements_ = requirements_.getUnmodifiableView();
      }
      if (((mutable_bitField0_ & 0x00000002) != 0)) {
        rules_ = java.util.Collections.unmodifiableList(rules_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.api.UsageProto.internal_static_google_api_Usage_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.api.Usage.class, org.apache.ratis.thirdparty.com.google.api.Usage.Builder.class);
  }

  public static final int REQUIREMENTS_FIELD_NUMBER = 1;
  private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList requirements_;
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @return A list containing the requirements.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getRequirementsList() {
    return requirements_;
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @return The count of requirements.
   */
  public int getRequirementsCount() {
    return requirements_.size();
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @param index The index of the element to return.
   * @return The requirements at the given index.
   */
  public java.lang.String getRequirements(int index) {
    return requirements_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @param index The index of the value to return.
   * @return The bytes of the requirements at the given index.
   */
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getRequirementsBytes(int index) {
    return requirements_.getByteString(index);
  }

  public static final int RULES_FIELD_NUMBER = 6;
  private java.util.List<org.apache.ratis.thirdparty.com.google.api.UsageRule> rules_;
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.ratis.thirdparty.com.google.api.UsageRule> getRulesList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder> getRulesOrBuilderList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public int getRulesCount() {
    return rules_.size();
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.api.UsageRule getRules(int index) {
    return rules_.get(index);
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder getRulesOrBuilder(int index) {
    return rules_.get(index);
  }

  public static final int PRODUCER_NOTIFICATION_CHANNEL_FIELD_NUMBER = 7;
  private volatile java.lang.Object producerNotificationChannel_;
  /**
   *
   *
   * <pre>
   * The full resource name of a channel used for sending notifications to the
   * service producer.
   * Google Service Management currently only supports
   * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
   * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
   * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
   * documented in https://cloud.google.com/pubsub/docs/overview.
   * </pre>
   *
   * <code>string producer_notification_channel = 7;</code>
   *
   * @return The producerNotificationChannel.
   */
  @java.lang.Override
  public java.lang.String getProducerNotificationChannel() {
    java.lang.Object ref = producerNotificationChannel_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      producerNotificationChannel_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The full resource name of a channel used for sending notifications to the
   * service producer.
   * Google Service Management currently only supports
   * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
   * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
   * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
   * documented in https://cloud.google.com/pubsub/docs/overview.
   * </pre>
   *
   * <code>string producer_notification_channel = 7;</code>
   *
   * @return The bytes for producerNotificationChannel.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getProducerNotificationChannelBytes() {
    java.lang.Object ref = producerNotificationChannel_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      producerNotificationChannel_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < requirements_.size(); i++) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, requirements_.getRaw(i));
    }
    for (int i = 0; i < rules_.size(); i++) {
      output.writeMessage(6, rules_.get(i));
    }
    if (!getProducerNotificationChannelBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 7, producerNotificationChannel_);
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    {
      int dataSize = 0;
      for (int i = 0; i < requirements_.size(); i++) {
        dataSize += computeStringSizeNoTag(requirements_.getRaw(i));
      }
      size += dataSize;
      size += 1 * getRequirementsList().size();
    }
    for (int i = 0; i < rules_.size(); i++) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(6, rules_.get(i));
    }
    if (!getProducerNotificationChannelBytes().isEmpty()) {
      size +=
          org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(7, producerNotificationChannel_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.api.Usage)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.api.Usage other = (org.apache.ratis.thirdparty.com.google.api.Usage) obj;

    if (!getRequirementsList().equals(other.getRequirementsList())) return false;
    if (!getRulesList().equals(other.getRulesList())) return false;
    if (!getProducerNotificationChannel().equals(other.getProducerNotificationChannel()))
      return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getRequirementsCount() > 0) {
      hash = (37 * hash) + REQUIREMENTS_FIELD_NUMBER;
      hash = (53 * hash) + getRequirementsList().hashCode();
    }
    if (getRulesCount() > 0) {
      hash = (37 * hash) + RULES_FIELD_NUMBER;
      hash = (53 * hash) + getRulesList().hashCode();
    }
    hash = (37 * hash) + PRODUCER_NOTIFICATION_CHANNEL_FIELD_NUMBER;
    hash = (53 * hash) + getProducerNotificationChannel().hashCode();
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.api.Usage prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Configuration controlling usage of a service.
   * </pre>
   *
   * Protobuf type {@code google.api.Usage}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.api.Usage)
      org.apache.ratis.thirdparty.com.google.api.UsageOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.api.UsageProto.internal_static_google_api_Usage_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.api.Usage.class, org.apache.ratis.thirdparty.com.google.api.Usage.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.api.Usage.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
        getRulesFieldBuilder();
      }
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      requirements_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000001);
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        rulesBuilder_.clear();
      }
      producerNotificationChannel_ = "";

      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.api.Usage getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.api.Usage.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.api.Usage build() {
      org.apache.ratis.thirdparty.com.google.api.Usage result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.api.Usage buildPartial() {
      org.apache.ratis.thirdparty.com.google.api.Usage result = new org.apache.ratis.thirdparty.com.google.api.Usage(this);
      int from_bitField0_ = bitField0_;
      if (((bitField0_ & 0x00000001) != 0)) {
        requirements_ = requirements_.getUnmodifiableView();
        bitField0_ = (bitField0_ & ~0x00000001);
      }
      result.requirements_ = requirements_;
      if (rulesBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)) {
          rules_ = java.util.Collections.unmodifiableList(rules_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.rules_ = rules_;
      } else {
        result.rules_ = rulesBuilder_.build();
      }
      result.producerNotificationChannel_ = producerNotificationChannel_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.api.Usage) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.api.Usage) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.api.Usage other) {
      if (other == org.apache.ratis.thirdparty.com.google.api.Usage.getDefaultInstance()) return this;
      if (!other.requirements_.isEmpty()) {
        if (requirements_.isEmpty()) {
          requirements_ = other.requirements_;
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          ensureRequirementsIsMutable();
          requirements_.addAll(other.requirements_);
        }
        onChanged();
      }
      if (rulesBuilder_ == null) {
        if (!other.rules_.isEmpty()) {
          if (rules_.isEmpty()) {
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureRulesIsMutable();
            rules_.addAll(other.rules_);
          }
          onChanged();
        }
      } else {
        if (!other.rules_.isEmpty()) {
          if (rulesBuilder_.isEmpty()) {
            rulesBuilder_.dispose();
            rulesBuilder_ = null;
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000002);
            rulesBuilder_ =
                org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getRulesFieldBuilder()
                    : null;
          } else {
            rulesBuilder_.addAllMessages(other.rules_);
          }
        }
      }
      if (!other.getProducerNotificationChannel().isEmpty()) {
        producerNotificationChannel_ = other.producerNotificationChannel_;
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.api.Usage parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.api.Usage) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int bitField0_;

    private org.apache.ratis.thirdparty.com.google.protobuf.LazyStringList requirements_ =
        org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;

    private void ensureRequirementsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        requirements_ = new org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList(requirements_);
        bitField0_ |= 0x00000001;
      }
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return A list containing the requirements.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ProtocolStringList getRequirementsList() {
      return requirements_.getUnmodifiableView();
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return The count of requirements.
     */
    public int getRequirementsCount() {
      return requirements_.size();
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index of the element to return.
     * @return The requirements at the given index.
     */
    public java.lang.String getRequirements(int index) {
      return requirements_.get(index);
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the requirements at the given index.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getRequirementsBytes(int index) {
      return requirements_.getByteString(index);
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index to set the value at.
     * @param value The requirements to set.
     * @return This builder for chaining.
     */
    public Builder setRequirements(int index, java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureRequirementsIsMutable();
      requirements_.set(index, value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param value The requirements to add.
     * @return This builder for chaining.
     */
    public Builder addRequirements(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureRequirementsIsMutable();
      requirements_.add(value);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param values The requirements to add.
     * @return This builder for chaining.
     */
    public Builder addAllRequirements(java.lang.Iterable<java.lang.String> values) {
      ensureRequirementsIsMutable();
      org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, requirements_);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearRequirements() {
      requirements_ = org.apache.ratis.thirdparty.com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param value The bytes of the requirements to add.
     * @return This builder for chaining.
     */
    public Builder addRequirementsBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      ensureRequirementsIsMutable();
      requirements_.add(value);
      onChanged();
      return this;
    }

    private java.util.List<org.apache.ratis.thirdparty.com.google.api.UsageRule> rules_ = java.util.Collections.emptyList();

    private void ensureRulesIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        rules_ = new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.api.UsageRule>(rules_);
        bitField0_ |= 0x00000002;
      }
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.api.UsageRule,
            org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder,
            org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder>
        rulesBuilder_;

    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.api.UsageRule> getRulesList() {
      if (rulesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rules_);
      } else {
        return rulesBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public int getRulesCount() {
      if (rulesBuilder_ == null) {
        return rules_.size();
      } else {
        return rulesBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public org.apache.ratis.thirdparty.com.google.api.UsageRule getRules(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder setRules(int index, org.apache.ratis.thirdparty.com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.set(index, value);
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder setRules(int index, org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.set(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(org.apache.ratis.thirdparty.com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(int index, org.apache.ratis.thirdparty.com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(index, value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(int index, org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addAllRules(java.lang.Iterable<? extends org.apache.ratis.thirdparty.com.google.api.UsageRule> values) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, rules_);
        onChanged();
      } else {
        rulesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder clearRules() {
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        rulesBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder removeRules(int index) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.remove(index);
        onChanged();
      } else {
        rulesBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder getRulesBuilder(int index) {
      return getRulesFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder getRulesOrBuilder(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<? extends org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder> getRulesOrBuilderList() {
      if (rulesBuilder_ != null) {
        return rulesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rules_);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder addRulesBuilder() {
      return getRulesFieldBuilder().addBuilder(org.apache.ratis.thirdparty.com.google.api.UsageRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder addRulesBuilder(int index) {
      return getRulesFieldBuilder()
          .addBuilder(index, org.apache.ratis.thirdparty.com.google.api.UsageRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder> getRulesBuilderList() {
      return getRulesFieldBuilder().getBuilderList();
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.api.UsageRule,
            org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder,
            org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder>
        getRulesFieldBuilder() {
      if (rulesBuilder_ == null) {
        rulesBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.api.UsageRule,
                org.apache.ratis.thirdparty.com.google.api.UsageRule.Builder,
                org.apache.ratis.thirdparty.com.google.api.UsageRuleOrBuilder>(
                rules_, ((bitField0_ & 0x00000002) != 0), getParentForChildren(), isClean());
        rules_ = null;
      }
      return rulesBuilder_;
    }

    private java.lang.Object producerNotificationChannel_ = "";
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return The producerNotificationChannel.
     */
    public java.lang.String getProducerNotificationChannel() {
      java.lang.Object ref = producerNotificationChannel_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        producerNotificationChannel_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return The bytes for producerNotificationChannel.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getProducerNotificationChannelBytes() {
      java.lang.Object ref = producerNotificationChannel_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        producerNotificationChannel_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @param value The producerNotificationChannel to set.
     * @return This builder for chaining.
     */
    public Builder setProducerNotificationChannel(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      producerNotificationChannel_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearProducerNotificationChannel() {

      producerNotificationChannel_ = getDefaultInstance().getProducerNotificationChannel();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @param value The bytes for producerNotificationChannel to set.
     * @return This builder for chaining.
     */
    public Builder setProducerNotificationChannelBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      producerNotificationChannel_ = value;
      onChanged();
      return this;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.api.Usage)
  }

  // @@protoc_insertion_point(class_scope:google.api.Usage)
  private static final org.apache.ratis.thirdparty.com.google.api.Usage DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.api.Usage();
  }

  public static org.apache.ratis.thirdparty.com.google.api.Usage getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<Usage> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<Usage>() {
        @java.lang.Override
        public Usage parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new Usage(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<Usage> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<Usage> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.api.Usage getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
